
%global meadversion 7.2.1
%global namedversion 7.2.1.Final-redhat-10
%global meadalpha .Final_redhat_10
%global meadrel .1
%global serial 6

%global fullreltag %{meadalpha}
%global prodversion 6.1

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without mead

%define base_name jbossas
# jbhomedir is /usr/share/jbossas  (files must be immutable)
%define jbhomedir %{_datadir}/%{base_name}
# jbossdir is /var/lib/jbossas  (any mutable file like logs must go here)
%define jbossdir %{_localstatedir}/lib/%{base_name}
# jbosslogdir is /var/log/jbossas  (any logs must go here)
%define jbosslogdir %{_localstatedir}/log/%{base_name}
# jbstandalonelogdir is /var/log/jbossas/standalone  (any mutable file like logs must go here)
%define jbstandalonelogdir %{jbosslogdir}/standalone
# jbosstmpdir is /var/cache/jbossas (Application cache data)
%define jbosstmpdir %{_localstatedir}/cache/%{base_name}
# jbstandalonetmpdir is /var/cache/jbossas/standalone
%define jbstandalonetmpdir %{jbosstmpdir}/standalone

%define maven_version 7.2.1-4.Final_redhat_10.1.ep6.el6

Name: jbossas-standalone
Epoch:		  0
Version: %{meadversion}
Release: %{serial}%{meadalpha}%{meadrel}%{?dist}
Summary: EAP 6 AS Standalone Configuration
License: OpenSource
URL:              https://github.com/jbossas/jboss-as
Group: Development/Libraries

%if %with mead
Source102: jbossas-standalone-7.2.1.Final-redhat-10.zip
Source103: jbossas-standalone-7.2.1.Final-redhat-10.pom
%endif


# These should be in sync with the ones in jbossas-domain
Source1:        jbossas.conf
Source2:        jbossas.init

Patch1:         jbossas-standalone-no-jar-index.patch

Provides: jbossas-configuration = %{epoch}:%{version}-%{release}

BuildRequires:    jpackage-utils

Requires:         jpackage-utils
Requires:         java
Requires:         jbossas-core

BuildArch:        noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

%description
EAP AS 6 Standalone Configuration.

%prep
unzip %{_sourcedir}/%{name}-%{namedversion}.zip \
      jboss-eap-%{prodversion}/bin/standalone.sh \
      jboss-eap-%{prodversion}/bin/standalone.conf \
      jboss-eap-%{prodversion}/docs/examples/configs/standalone* \
      jboss-eap-%{prodversion}/standalone/*


%build
                                                                                                     
%install
pushd jboss-eap-%{prodversion}

# Create directories
# Variable files go there
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/standalone
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/standalone/deployments
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/standalone/lib
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/standalone/lib/ext
# Config files go there
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/standalone
# Directory for immutable files
# Links to variable file and config file locations make it appear
# like a full JBOSS_HOME tree
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}
# Log dir for standalone /var/log/jbossas/standalone
install -d -m 755 $RPM_BUILD_ROOT%{jbstandalonelogdir}
# Application cache data dir for standalone /var/cache/jbossas/standalone
install -d -m 755 $RPM_BUILD_ROOT%{jbstandalonetmpdir}
install -d -m 755 $RPM_BUILD_ROOT%{jbstandalonetmpdir}/auth

# Symlink to re-create a JBOSS_HOME
%{__ln_s} %{jbossdir}/standalone $RPM_BUILD_ROOT%{jbhomedir}/standalone
# The one below is $RPM_BUILD_ROOT%{jbhomedir}/standalone/configuration
%{__ln_s} %{_sysconfdir}/%{base_name}/standalone \
          $RPM_BUILD_ROOT%{jbossdir}/standalone/configuration
# The one below is for where log files go
# /var/lib/jbossas/standalone/log  --> /var/log/jbossas/standalone
%{__ln_s} %{jbstandalonelogdir} $RPM_BUILD_ROOT%{jbossdir}/standalone/log
# The one below is for where Application cache data go
# /var/lib/jbossas/standalone/tmp  --> /var/cache/jbossas/standalone
# Do this in post or it will fail when upgrading old releases that have a real file
#%%{__ln_s} %{jbstandalonetmpdir} $RPM_BUILD_ROOT%{jbossdir}/standalone/tmp
touch $RPM_BUILD_ROOT%{jbossdir}/standalone/tmp

# Now install files

# bin dir scripts
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}/bin
%{__cp} -pr bin/* $RPM_BUILD_ROOT%{jbhomedir}/bin
pushd $RPM_BUILD_ROOT%{jbhomedir}/bin
   %{__patch} -p0 < %{PATCH1}
popd

# Example config
%{__cp} -pr standalone/configuration/* \
            $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/standalone

# README file
%{__cp} -pr standalone/deployments/* \
            $RPM_BUILD_ROOT%{jbossdir}/standalone/deployments

# Global configuration file
# Permissions removed for JBPAPP-9593
install -d -m 750 $RPM_BUILD_ROOT%{_sysconfdir}/jbossas
cat > jbossas.conf << EOT
# System-wide configuration file for jbossas services
# This will be sourced by jbossas and any secondary service
# Values will be overridden by service-specific configuration
# files in /etc/sysconfig
# Use this one to change default values for all services
# Change the service specific ones to affect only one service
# (see, for instance, /etc/sysconfig/jbossas)
#
# To change a setting, uncomment the line and set the value for what you want
# The values in the comments are the default values, shown here for convenience
#
EOT
cat %{SOURCE1} >> jbossas.conf
sed -i -e '/Define host configuration to start, eg. host.xml/,+2d' jbossas.conf
install -p -m 644 jbossas.conf $RPM_BUILD_ROOT%{_sysconfdir}/jbossas
rm jbossas.conf
# Service-specific configuration file
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
cat > jbossas << EOT
# Service-specific configuration file for jbossas services
# This will be sourced by the SysV service script after the global
# configuration file /etc/jbossas/jbossas.conf, thus allowing values
# to be overridden on a per-service way
#
# NEVER change the init script itself:
# To change values for all services make your changes in
# /etc/jbossas/jbossas.conf
# To change values for a specific service, change it here
# To create a new service, create a link from /etc/init.d/<you new service> to
# /etc/init.d/jbossas (do not copy the init script) and make a copy of the
# /etc/sysconfig/jbossas file to /etc/sysconfig/<you new service> and change
# the property values so the two services won't conflict
# Register the new service in the system as usual (see chkconfig and similars)
#
# To change a setting, uncomment the line and set the value for what you want
# The values in the comments are the default values, shown here for convenience
#
EOT
cat %{SOURCE1} >> jbossas
sed -i -e '/Define host configuration to start, eg. host.xml/,+2d' jbossas
install -p -m 644 jbossas $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/jbossas

#init script
install -d -m 755 $RPM_BUILD_ROOT%{_initrddir}
install -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/jbossas
sed -i -e '/define the host configuration/,+1d' -e '/JBOSS_HOST_CONFIG/,+2d' $RPM_BUILD_ROOT%{_initrddir}/jbossas

popd
                                                                                                     
%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{_localstatedir}/lib/jbossas -g jboss jboss 2>/dev/null || :
if [ "$1" = 2 ]; then
  # stop server before upgrade
  %{_initrddir}/jbossas stop >/dev/null 2>&1 || :
fi

%post
# add jbossas service
[ -x /sbin/chkconfig ] && /sbin/chkconfig --add jbossas || :
if [ "$1" = 1 ]; then
# Create this symlink only on a fresh install as we cannot replace
# a real directory from a previous install with a symlink
%{__ln_s} %{jbstandalonetmpdir} $RPM_BUILD_ROOT%{jbossdir}/standalone/tmp
else
# If we are updating, make sure the /var/cache/jbossas directory has the
# right permissions as requested in BZ#900891
chown jboss:jboss %{jbosstmpdir}
chmod 750  %{jbosstmpdir}
fi

%preun
if [ "$1" = 0 ]; then
  # stop and remove service on erase
  %{_initrddir}/jbossas stop > /dev/null 2>&1 || :
  [ -x /sbin/chkconfig ] && /sbin/chkconfig --del jbossas
fi

%clean
                                                                                                     
%files
# Variable files will go here
# Permissions removed for JBPAPP-9593
%defattr(0644,jboss,jboss,0750)
%dir %{jbossdir}
%dir %{jbossdir}/standalone
%defattr(0644,jboss,jboss,0755)
%dir %{jbossdir}/standalone/deployments
%{jbossdir}/standalone/deployments/README.txt
%dir %{jbossdir}/standalone/tmp
%dir %{jbossdir}/standalone/lib
%dir %{jbossdir}/standalone/lib/ext
# Log files will go here
%dir %{jbstandalonelogdir}
%dir %{jbossdir}/standalone/log
# Tmp files will go here
%dir %{jbstandalonetmpdir}
%dir %{jbstandalonetmpdir}/auth
# This link is created in post when possible
%ghost %dir %{jbossdir}/standalone/tmp
# Scrips
%dir %{jbhomedir}
%dir %{jbhomedir}/bin
%attr(0755,jboss,jboss) %{jbhomedir}/bin/standalone.sh
%config %{jbhomedir}/bin/standalone.conf
# JBOSS_HOME symlinks
%dir %{jbhomedir}/standalone
#%%dir %{jbhomedir}/standalone/configuration
%dir %{jbossdir}/standalone/configuration
#init script
%attr(0755,root,root) %{_initrddir}/jbossas
#system wide config file
%{_sysconfdir}/jbossas
%config(noreplace) %{_sysconfdir}/jbossas/*.conf
#service specific config file
%config(noreplace) %{_sysconfdir}/sysconfig/jbossas
# Config files will go here
# Permissions removed for JBPAPP-9593
# Note the %%defattr if you put anything past this line
%defattr(0644,jboss,jboss,0750)
%dir %{_sysconfdir}/%{base_name}
%dir %{_sysconfdir}/%{base_name}/standalone
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone-ha.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone-full.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/standalone-full-ha.xml
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/logging.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/mgmt-users.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/application-roles.properties
%config(noreplace) %{_sysconfdir}/%{base_name}/standalone/application-users.properties

%changelog
* Wed Aug 21 2013 Permaine Cheung <pcheung@redhat.com> - 7.2.1-7.Final_redhat_10
- EAP 6.1.1 ER7

* Tue Aug 13 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-5.Final_redhat_8
- Make standalone.conf a config file (BZ#979125)

* Tue Aug 13 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-4.Final_redhat_8
- EAP 6.1.1 ER5

* Tue Jul 30 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-3.Final_redhat_5
- EAP 6.1.1 ER4

* Wed Jul 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.1-3.Final_redhat_4
- EAP 6.1.1 ER3

* Thu May 09 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-8.Final_redhat_8
- EAP 6.1.0 ER8

* Wed May 08 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-7.Final_redhat_7
- EAP 6.1.0 ER7

* Tue Apr 30 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-6.Final_redhat_6
- EAP 6.1.0 ER6

* Wed Apr 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-5.Final_redhat_5
- EAP 6.1.0 ER5

* Wed Apr 17 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-5.Final_redhat_5
- EAP 6.1.0 ER5

* Tue Apr 02 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-4.Final_redhat_4
- EAP 6.1.0 ER4

- Add fix for BZ#900891

* Tue Mar 19 2013 Permaine Cheung <pcheung@redhat.com> - 7.2.0-3.1.Final_redhat_3
- Add fix for BZ 920742

* Tue Mar 15 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-3.Final_redhat_3
- EAP 6.1.0 ER3

* Tue Mar 12 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-3.Final_redhat_2.1
- Create symlink for tmp only on a fresh install, and do it in post

* Tue Mar 05 2013 Fernando Nasser <fnasser@redhat.com> - 7.2.0-3.Final_redhat_2
- EAP 6.1.0 ER2

* Wed Jan 30 2013 Fernando Nasser <fnasser@redhat.com> - 7.1.3-5.1.Final_redhat_4
- Install tmp directory in /var/cache to comply with LFS

* Wed Jan 30 2013 Permaine Cheung <pcheung@redhat.com> - 7.1.3-5.Final_redhat_4
- Add init script fix for BZ 905673

* Thu Nov 22 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-4.Final_redhat_4
- EAP 6.0.1 ER4

* Thu Nov 22 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-4.Final_redhat_4
- EAP 6.0.1 ER4

* Wed Oct 24 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.2.Final_redhat_3
- Use %%defattr for dir perms (for JBPAPP-9593)

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.1.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Oct 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-3.Final_redhat_3
- EAP 6.0.1 ER3

* Fri Sep 28 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.1.Final_redhat_2
- Use smaller ZIP as source

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2.1
- Rebuild for MD5

* Mon Sep 17 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2
- EAP 6.0.1 ER2

* Mon Sep 17 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-2.Final_redhat_2
- EAP 6.0.1 ER2

* Fri Sep 14 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-1.1.Final_redhat_1
- Permissions removed for JBPAPP-9593
From Permaine Cheung <pcheung@redhat.com>:
- Init script fixes for JBPAPP-9395, 9304, 9612, 9364

* Wed Sep 05 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.3-1.Final_redhat_1
- EAP 6.0.1 ER1

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.1.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.1.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-11.Final_redhat_1
- Rebuild of 6.0.0.GA unsigned

* Thu Jun 07 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.2-8.Final_redhat_1
- Init script fixes - JBPAPP-9301, 9302, 9303

* Tue May 29 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-7.Final_redhat_1
- CR1 build

* Thu May 24 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-6.1.Final_redhat_1
- ER9 build

* Wed May 16 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.2-6.Final_redhat_1
- Init script fixes - report success on stopping a stopped service, report
  success on starting on an already started service, check if process is
  running in status and stop even if pid does not exist, add loop for wait
  time in start if port is busy

* Tue May 15 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-5.Final_redhat_1
- ER8 build

* Thu May 10 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.2-1.Final
- Upgrade to 7.1.2.Final

*Thu Apr 19 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-6.Final
- Rebuild with apache-commons-*-eap6 and some other packages rebuilt w/ fixes

* Tue Apr 17 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-5.Final
- Return 0 for starting of service if already running

* Tue Apr 17 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-4.Final
- Return 0 for stopping of service if not running

* Mon Apr 16 2012 Permaine Cheung <pcheung@redhat.com> - 7.1.1-3.Final
- Fix return value of init script to be the same as the function returns

*Wed Apr 11 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-2.Final
- Rebuild with -eap6 and some other package fixes

* Wed Apr 11 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-2.Final
- Rebuild with -eap6 and some other package fixes

*Fri Mar 30 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.1-1.Final.1
- Upgrade to 7.1.1.Final+  (ER4.1)

* Wed Mar 14 2012 Fernando Nasser <fnasser@redhat.com> - 7.1.0-1.Final
- Upgrade to ER3

* Mon Feb 27 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.10
- Update init script to sync with the one in jbossas-domain

* Thu Feb 23 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.9
- Move creation and linking of log dir to spec file from init script

* Thu Feb 23 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.8
- Init script fix: Fix linking of log dir

* Thu Feb 23 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.7
- Init script fix: Kill child processes when stopping the service

* Thu Feb 23 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.6
- Init script fixes: JBOSS_SERVER_CONFIG defaults to empty, link log dir to 
  /var/log

* Thu Feb 16 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.5
- init script fixes

* Tue Feb 14 2012 Permaine Cheung <pcheung@redhat.com> - 0:7.1.0-0.1.CR1.4
- Add init script and sysconfig files
- Update pre, post, preun sections to work with init scripts and service

* Tue Jan 24 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.3
- Fix useradd

* Mon Jan 23 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.2
- Add provides jbossas-configuration

* Mon Jan 23 2012 Fernando Nasser <fnasser@redhat.com> - 0:7.1.0-0.1.CR1.1
- Wrap MEAD build for EAP 6

